/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

package CLI;

import java.util.*;
import java.io.*;
import util.*;

/*********************************************************
* Main class for command line profile checking tool.
*
* @author Olav Haugan
*
* Date: 14.10.01
*********************************************************/
public class CheckProfile
{
	/*********************************************************
	* Creates an ProfileChecker and checks the profile config.
	*
	* @param String[] The command line arguments
	*********************************************************/
	public static void main( String args[] )
	{
		if( args.length == 0 )
		{
			System.out.println( "Usage: CheckProfile <profile file>" );
			return;
		}	

		File file = new File( args[0] );

		ProfileChecker profiler = new ProfileChecker(file);
		if(profiler.isProfileValid())
		{
			System.out.println("Configuration is valid");
		}
		else
		{
			profiler.errors();
		}
	}
}	
