/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

package ZEN_IDL.be;

import java.io.*;
import java.io.PrintWriter;
import java.util.*;
import ZEN_IDL.ast.*;
import ZEN_IDL.be.symbolTableUtils.*;
import ZEN_IDL.be.helperUtils.*;

public class SymbolTableExceptionVisitor extends AbstractVisitor
{
	public Object visit(ASTscoped_name node, Object data)
        {
                VisitorState mState = (VisitorState) data;

                String firstToken = node.getFirstToken().toString();
                boolean absoluteScope = false;
                if( firstToken.trim().equals( "::" ) )
                {
                        absoluteScope = true;
                }

                int numChildren = node.jjtGetNumChildren();
                Vector scopedNameElements = new Vector();
                for( int i = 0 ; i < numChildren ; i++ ){
                        scopedNameElements.add(
				(Object) node.jjtGetChild(i).getFirstToken().toString() );
		}
		mState.addException( scopedNameElements );
                return data;
        }
}


