/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

package setup;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

/**
 * <p>Title: MQC Setup</p>
 * <p>Description: Setup utility for MQC</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Eivind Naess
 * @version 1.0
 */

public class Frame1 extends JFrame {
  JPanel contentPane;
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JMenuItem jMenuFileExit = new JMenuItem();
  JMenu jMenuHelp = new JMenu();
  JMenuItem jMenuHelpAbout = new JMenuItem();
  JTextField jTextField1 = new JTextField();
  JTextField jTextField2 = new JTextField();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JButton jButton1 = new JButton();
  JButton jButton2 = new JButton();
  JLabel jLabel3 = new JLabel();
  JTextField jTextField3 = new JTextField();
  JMenuItem jMenuSave_AS = new JMenuItem();
  JRadioButton jRadioButton1 = new JRadioButton();
  JRadioButton jRadioButton2 = new JRadioButton();
  ButtonGroup buttonGrp = new ButtonGroup();
  JPanel jPanel1 = new JPanel();
  JLabel jLabel4 = new JLabel();

  //Construct the frame
  public Frame1() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  //Component initialization
  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(null);
    this.getContentPane().setBackground(SystemColor.control);
    jPanel1.setBackground(SystemColor.control);
    jPanel1.setBorder(BorderFactory.createTitledBorder("Path"));
    this.setContentPane(contentPane);
    this.setDefaultCloseOperation(HIDE_ON_CLOSE);
    this.setEnabled(true);
    this.setForeground(Color.black);
    this.setLocale(java.util.Locale.getDefault());
    this.setResizable(false);
    this.setSize(new Dimension(450, 250));
    this.setState(Frame.NORMAL);
    this.setTitle("Setup");
    jMenuFile.setText("File");
    jMenuFileExit.setText("Exit");
    jMenuFileExit.addActionListener(new Frame1_jMenuFileExit_ActionAdapter(this));
    jMenuSave_AS.addActionListener(new Frame1_jMenuSave_AS_ActionAdapter(this));
    jMenuHelp.setText("Help");
    jMenuHelpAbout.setText("About");
    jMenuHelpAbout.addActionListener(new Frame1_jMenuHelpAbout_ActionAdapter(this));
    jTextField1.setToolTipText("");
    if (System.getProperty("user.dir") != null)
    {
      jTextField1.setText(System.getProperty("user.dir"));
    }
    else
    {
      jTextField1.setText("<Install Directory>");
    }
    jTextField1.setBounds(new Rectangle(107, 17, 295, 23));
    jTextField2.setText(System.getProperty("java.home"));
    jTextField2.setBounds(new Rectangle(107, 43, 295, 23));
    jLabel1.setText("MQC Home:");
    jLabel1.setBounds(new Rectangle(15, 17, 83, 20));
    jLabel2.setText("Java Home:");
    jLabel2.setBounds(new Rectangle(15, 42, 83, 20));
    jButton1.setBounds(new Rectangle(194, 152, 109, 33));
    jButton1.setText("Save");
    jButton1.addActionListener(new Frame1_jButton1_actionAdapter(this));
    jButton2.setBounds(new Rectangle(309, 152, 109, 33));
    jButton2.setText("Exit");
    jButton2.addActionListener(new Frame1_jButton2_actionAdapter(this));
    contentPane.setBackground(SystemColor.control);
    contentPane.setPreferredSize(new Dimension(400, 220));
    contentPane.setToolTipText("");
    jLabel3.setText("Tools:");
    jLabel3.setBounds(new Rectangle(15, 69, 83, 20));
    if (System.getProperty("user.home") != null)
    {
      jTextField3.setText(System.getProperty("user.home" ) + File.separator + "MQCTools");
    }
    else
    {
      jTextField3.setText("<Third party tools>");
    }
    jTextField3.setBounds(new Rectangle(107, 70, 295, 23));
    jMenuSave_AS.setText("Save As");
    jRadioButton1.setBackground(SystemColor.control);
    jRadioButton1.setText("Bash");
    jRadioButton1.setBounds(new Rectangle(281, 102, 69, 23));
    jRadioButton2.setBackground(SystemColor.control);
    jRadioButton2.setEnabled(true);
    jRadioButton2.setSelected(true);
    jRadioButton2.setText("Csh");
    jRadioButton2.setBounds(new Rectangle(348, 102, 52, 23));
    jPanel1.setBounds(new Rectangle(4, 6, 414, 140));
    jPanel1.setLayout(null);
    jLabel4.setText("Shell:");
    jLabel4.setBounds(new Rectangle(228, 102, 43, 23));
    buttonGrp.add(jRadioButton2);
    buttonGrp.add(jRadioButton1);
    jMenuFile.add(jMenuSave_AS);
    jMenuFile.addSeparator();
    jMenuFile.add(jMenuFileExit);
    jMenuHelp.add(jMenuHelpAbout);
    jMenuBar1.add(jMenuFile);
    jMenuBar1.add(jMenuHelp);
    jPanel1.add(jTextField1, null);
    jPanel1.add(jTextField2, null);
    jPanel1.add(jTextField3, null);
    jPanel1.add(jLabel1, null);
    jPanel1.add(jLabel2, null);
    jPanel1.add(jLabel3, null);
    jPanel1.add(jRadioButton2, null);
    jPanel1.add(jRadioButton1, null);
    jPanel1.add(jLabel4, null);
    contentPane.add(jButton2, null);
    contentPane.add(jButton1, null);
    contentPane.add(jPanel1, null);
    this.setJMenuBar(jMenuBar1);
  }
  //File | Exit action performed
  public void jMenuFileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }
  //Help | About action performed
  public void jMenuHelpAbout_actionPerformed(ActionEvent e) {
    Frame1_AboutBox dlg = new Frame1_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.pack();
    dlg.show();
  }
  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      jMenuFileExit_actionPerformed(null);
    }
  }

  void jButton2_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  void jButton1_actionPerformed(ActionEvent e) {
    File f;
    export ex;
    JFileChooser ch = new JFileChooser(System.getProperty("user.dir"));
    ExportFileFilter filter = new ExportFileFilter();
    ch.setFileFilter(filter);

    int temp1 = ch.showSaveDialog(this);
    if (temp1 == ch.APPROVE_OPTION)
    {
      ex = new export (jTextField2.getText(),
                       jTextField1.getText(),
                       jTextField3.getText(),
                       "~/MQC-ark", "z:/MQC-ark");
      f = ch.getSelectedFile();

      if (jRadioButton1.isSelected() &&
          !f.getName().endsWith(".bash"))
        f = new File (f.getAbsolutePath() + ".bash");
      else if (jRadioButton2.isSelected() &&
               !f.getName().endsWith(".csh"))
        f = new File (f.getAbsolutePath() + ".csh");

      if (f.exists())
      {
        Object [] choices = {"Yes", "No"};
        int temp = JOptionPane.showOptionDialog(this,
                                      "File " + f.getName() + " exists, Overwrite?",
                                      "File exists!",
                                      JOptionPane.YES_NO_OPTION,
                                      JOptionPane.WARNING_MESSAGE,
                                      null,
                                      choices,
                                      null
                                      );
        if (temp == 1)
          return;
      }
    } else
    {
      return;
    }

    if (jRadioButton1.isSelected())
    {
      ex.export_bash(f);
    } else if (jRadioButton2.isSelected())
    {
      ex.export_csh(f);
    }
  }
}

class Frame1_jMenuFileExit_ActionAdapter implements ActionListener {
  Frame1 adaptee;

  Frame1_jMenuFileExit_ActionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuFileExit_actionPerformed(e);
  }
}

class Frame1_jMenuSave_AS_ActionAdapter implements ActionListener {
  Frame1 adaptee;

  Frame1_jMenuSave_AS_ActionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}

class Frame1_jMenuHelpAbout_ActionAdapter implements ActionListener {
  Frame1 adaptee;

  Frame1_jMenuHelpAbout_ActionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuHelpAbout_actionPerformed(e);
  }
}

class Frame1_jButton2_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_jButton2_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton2_actionPerformed(e);
  }
}

class Frame1_jButton1_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_jButton1_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}
