/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

import mqc.*;
import mqc.holders.*;

import java.io.*;

public class Server
{
   public static void main(String[] args)
   {
      S_ORB orb = new S_ORB();
      System.out.println("ORB created!");

      POA rootPOA = new POA(orb, "RootPOA");
      bankImpl test = new bankImpl();

      Object object = rootPOA.servant_to_reference( test );

      String ior    = orb.object_to_string(object);
      System.out.println("object to string");
      System.out.println(ior);

      String corbaloc = orb.object_to_corbaloc(object);
      System.out.println("object to corbaloc!");
      System.out.println(corbaloc);

      try
      {
         FileWriter out = new FileWriter(new File("banker.ior"));
         out.write(ior);
         out.close();

         out = new FileWriter(new File("banker.corbaloc"));
         out.write(corbaloc);
         out.close();
      }
      catch(IOException e)
      {
         System.out.println("Error writing IOR/corbloc");
         return;
      }

      System.out.println("Waiting for requests...");
      orb.run();
   }
}
