/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

import mqc.*;
import mqc.holders.*;

public class Client
{
   public static void main(String[] args)
   {
      Object object;
      C_ORB orb = new C_ORB();
      System.out.println("ORB created!");

      String corbalocStr = System.getProperty("corbaloc");

      if (corbalocStr != null)
      {
         System.out.println("Using corbaloc property: " + corbalocStr);
         object = orb.corbaloc_to_object(corbalocStr);
      }
      else
      {
         System.out.println("Using args[0]: " + args[0]);
         object = orb.corbaloc_to_object(args[0]);
      }

      System.out.println("corbaloc to object!");

      simple.test1 tester = simple.test1Helper.narrow(object);
      System.out.println("Narrow!");
      byte res = 0;
      res = tester.fun1((byte) 127);
      if(res == 123)
         System.out.println("Success res");
      else
         System.out.println("Failure");

      boolean b = tester.fun2(true);
      if(b)
         System.out.println("Success b");
      else
         System.out.println("Failure");

      char c = tester.fun3('R');
      if(c == 'p')
         System.out.println("Success c");
      else
         System.out.println("Failure");

      short us = tester.fun4((short) 32323);
      if(us == 32123)
         System.out.println("Success us");
      else
         System.out.println("Failure");

      short s = tester.fun5((short) 32123);
      if(s == 32124)
         System.out.println("Success s");
      else
         System.out.println("Failure");

      int ui = tester.fun6((int) 1234561);
      if(ui == 123456)
         System.out.println("Success ui");
      else
         System.out.println("Failure");

      int i = tester.fun7((int) 234567);
      if(i == 654321)
         System.out.println("Success i");
      else
         System.out.println("Failure");

      long ul = tester.fun8((long) 23456700);
      if(ul == 1234567)
         System.out.println("Success ul");
      else
         System.out.println("Failure");

      long l = tester.fun9((long) 23456711);
      if(l == 7654321)
         System.out.println("Success l");
      else
         System.out.println("Failure");

      double d = tester.fun10((double) 123.23456);
      if(d == 123.4567)
         System.out.println("Success d");
      else
         System.out.println("Failure");

      float f = tester.fun11((float) 451.13);
      if((f*100) == 1234567)
         System.out.println("Success f");
      else
         System.out.println("Failure");

      tester.fun12(res, b, c, us, s, ui, i, ul, l, f, d);

      ByteHolder resH = new ByteHolder();
      resH.value = 123;
      BooleanHolder bH = new BooleanHolder();
      bH.value = false;
      CharHolder cH = new CharHolder();
      cH.value = 'w';
      ShortHolder usH = new ShortHolder();
      usH.value = 12312;
      ShortHolder sH = new ShortHolder();
      sH.value = 12321;
      IntHolder uiH = new IntHolder();
      uiH.value = 123222;
      IntHolder iH = new IntHolder();
      iH.value = 123232;
      LongHolder ulH = new LongHolder();
      ulH.value = 12322222;
      LongHolder lH = new LongHolder();
      lH.value = 12344444;
      FloatHolder fH = new FloatHolder();
      fH.value = 123.123f;
      DoubleHolder dH = new DoubleHolder();
      dH.value = 123.321;

      tester.fun13(resH, bH, cH, usH, sH, uiH, iH, ulH, lH, fH, dH);
      if(resH.value == 1   && bH.value == false   && cH.value  == 'n'   &&
            usH.value == 1234 && sH.value == 4321    && uiH.value == 12345 &&
            iH.value == 54321 && ulH.value == 123456 && lH.value == 654321 &&
            (fH.value*1000) == 2123 && dH.value == 3.12345)
         System.out.println("Success fun13");
      else
         System.out.println("Failure");

      tester.fun14(resH, bH, cH, usH, sH, uiH, iH, ulH, lH, fH, dH);
      if(resH.value == 1   && bH.value == false   && cH.value == 'n'     &&
            usH.value == 1234 && sH.value == 4321    && uiH.value == 12345  &&
            iH.value == 54321 && ulH.value == 123456 && lH.value == -654321 &&
            (fH.value*1000) == 2123 && dH.value == 3.12345)
         System.out.println("Success fun14");
      else
         System.out.println("Failure");

   }
}
