/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

// Do not use the package statement...it caused problems with loading/finding
// the right routines from the shared library.
//
//package jni;

//import java.util.*;

public class TSCTimer
{
   /**
    * init -- initialize the timing code (setup scale factors, etc).
    * 
    * @param  ticksPerSecond -- used to scale the TSC results to ms, us, etc.
    */
   public static native void   init(int ticksPerSecond);

   /**
    * currentTimeTSC -- return the current (scaled) TSC time
    *
    */
   public static native long   currentTime();

   /**
    * getTimeResolution -- return the resolution (ie, ticks per second)
    *
    * @return double -- the timer resolution (number of ticks per second)
    */
   public static native double getTimeResolution();

   static
   {
      System.loadLibrary("CTSCTimer");
   }

   /*
   public static void main(String[] args)
   {
      long tsc, tsc0;
      long millis, millis0;

      TSCTimer mqcTimer = new TSCTimer();

      mqcTimer.init(100000);

      System.out.println("Time: " + mqcTimer.currentTime());

      System.out.println("tConv: " + mqcTimer.getTimeResolution());

      double tscConv = TSCTimer.getTimeResolution();

      tsc0    = TSCTimer.currentTime();
      millis0 = System.currentTimeMillis();

      for (int i = 0;  i < 20;  i++) {
         tsc    = TSCTimer.currentTime()  - tsc0;
         millis = System.currentTimeMillis() - millis0;

         System.out.println("Millis: " + millis + " \tTSC: " + tsc + " \tuSec: " + ((double)(1000000.*tsc)/tscConv) );
      }

      for (int i = 0;  i < 200;  i++) {
         tsc    = TSCTimer.currentTime()  - tsc0;
         millis = System.currentTimeMillis() - millis0;

         System.out.println("Millis: " + millis + " \tTSC: " + tsc + " \tuSec: " + ((double)(1000000.*tsc)/tscConv) );

         try {
            Thread.sleep(1000);
         }
         catch (InterruptedException ie) {
         }
      }
   }
   */
}
