/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

include(`Config_macros.m4')

package mqc;

import mqc.protocols.*;
import mqc.ior.*;

/**
 * GIOP protocol delegate
 *
 * @author Olav Haugan
 * @author David McKinnon
 * @author Kim Christian Swenson
 */
public class GIOPDelegate extends Delegate
{
   /**
    * Constructor. Initializes variables.
    */
   public GIOPDelegate(ORB orb, IOR ior, boolean big )
   {
      super(orb, ior, big);
      protocol = GIOP_PROT;

      GIOPHeader req_GIOPHeader;
      GIOPHeader rep_GIOPHeader;
      GIOPRequestHeader l_GIOPRequestHeader;
      GIOPReplyHeader l_GIOPReplyHeader;

      __GIOP10__(
         req_GIOPHeader = new GIOPHeader_1_0();
         rep_GIOPHeader = new GIOPHeader_1_0();
         l_GIOPRequestHeader = new GIOPRequestHeader_1_0();
         l_GIOPReplyHeader = new GIOPReplyHeader_1_0();
      )
      __GIOP11__(
         req_GIOPHeader = new GIOPHeader_1_1();
         rep_GIOPHeader = new GIOPHeader_1_1();
         l_GIOPRequestHeader = new GIOPRequestHeader_1_1();
         l_GIOPReplyHeader = new GIOPReplyHeader_1_1();
      )
      __GIOP12__(
         req_GIOPHeader = new GIOPHeader_1_2();
         rep_GIOPHeader = new GIOPHeader_1_2();
         l_GIOPRequestHeader = new GIOPRequestHeader_1_2();
         l_GIOPReplyHeader = new GIOPReplyHeader_1_2();
      )
      __GIOP13__(
         req_GIOPHeader = new GIOPHeader_1_3();
         rep_GIOPHeader = new GIOPHeader_1_3();
         l_GIOPRequestHeader = new GIOPRequestHeader_1_3();
         l_GIOPReplyHeader = new GIOPReplyHeader_1_3();
      )

      m_reply = new GIOPReply( rep_GIOPHeader, l_GIOPReplyHeader );
      m_request = new GIOPRequest( req_GIOPHeader, l_GIOPRequestHeader );

   }

}

