/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

package mqc.ior;

/**
* The UDPxIIOPLite profile class.
*
* @author Eivind Naess
*/
public class UIOPLiteProfile extends TaggedProfile
{

  /**
   * Constructor for UIOPLiteProfile
   */
   public UIOPLiteProfile()
   {
      super(TaggedProfile.UIOPLITE);
   }

  /**
   * Encodes a corbaloc String from this profile (UIOPLite)
   * @param corbalocStr String buffer
   * @return a Corbaloc formated String
   */
   public String encodeCorbalocProfile(String corbalocStr)
   {
      corbalocStr = super.encodeCorbalocProfile ("uioplite");
      return corbalocStr;
   }

  /**
   * Overides Clone in Object
   * @return a copy of itself
   */ 
   public Object clone ()
   {
      UIOPLiteProfile profile = new UIOPLiteProfile();
      profile.objectKey = new byte[objectKey.length];
      System.arraycopy(objectKey, 0, profile.objectKey, 0, objectKey.length);
      profile.seqLen = seqLen;
      profile.major = major;
      profile.minor = minor;
      profile.host = host;
      profile.port = port;
      profile.bigEndian = bigEndian;
      return profile;
   }
}
