/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

package mqc.transports;

import mqc.*;
import mqc.ior.*;
import mqc.holders.*;

import java.io.*;
import java.util.*;
import java.net.*;

/**
* Client Serial transport class
* 
* @author Olav Haugan
*
* 14.10.01
*/
public class SerialTransport extends Transport
{

   /**
   * Constructor. Initializes variables.
   */
   public SerialTransport()
   {
      super();
   }

   /**
   * Constructor. Initializes variables.
   * 
   * @param mqc.Delegate The delegate object
   */
   public SerialTransport(mqc.Delegate delegate)
   {
      super();
      Profile profile = delegate.ior.getProfile();
      init();
   }

   /**
   * Initializes a connection.
   *
   * @return boolean true if socket created successfully, false otherwise
   */
   public boolean init()
   {
      return true;
   }

   /**
   * Sends a message
   *
   * @param byte[] The buffer to send
   * @param int The number of bytes to transmit
   * @return boolean true if data is sent successfully, false
   * otherwise
   */
   public boolean send(byte[] buffer, int length)
   {
      return true;
   }

   /**
   * Waits for a message and receive it.
   *
   * @param Message The message sent
   * @param BooleanHolder true if big endian, false otherwise
   * @return byte[] The buffer received
   */
   public byte[] waitForReply(Message msg, BooleanHolder bigEndian)
   {
      return null;
   }
}
