/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

include(`Config_macros.m4')
package mqc.util;
import mqc.protocols.*;

public class msgPrinter 
{
   public static void printMessage(byte [] buf, int eom)
   {
		int msgType=0;
		Message msg = null;
      __GIOP_PROTOCOL__(
      if ((buf[0] == Message.GMAGIC) && (buf[1] == Message.IMAGIC) && 
			(buf[2] == Message.OMAGIC) && (buf[3] == Message.PMAGIC))
      {
			msgType = 2;
		}
      )
      __MQCIOP_PROTOCOL__(
      if ((buf[0] == Message.MMAGIC) && (buf[1] == Message.QMAGIC) && 
			 (buf[2] == Message.CMAGIC))
      {
			msgType = 1;
		}
      )

		switch (msgType) 
		{
			__GIOPLITE_PROTOCOL__(
			case 0:
				msg = new GIOPLiteMessage(buf);
				GIOPLiteHeader.deMarshal((GIOPLiteMessage) msg);				
				break;
			)
			__MQCIOP_PROTOCOL__(
			case 1:
	     		msg = new MQCIOPMessage(buf);
				MQCIOP.deMarshal((MQCIOPMessage) msg);				
				break;
			)
			__GIOP_PROTOCOL__(
			case 2:
	      	msg = new GIOPMessage(buf);
				GIOPHeader.deMarshal((GIOPMessage) msg);
				break;
			)
			default:
				System.out.println("**Warning: could not find the propper protocol");
				printHex(buf, 0, buf.length);
				return;
		}
		Request req = null;
		Reply rep = null;
		if (msg.getMessageType() == Message.REPLY_MSG)
		{
			__GIOP_PROTOCOL__(			
			if (msg instanceof GIOPMessage)
				rep = new GIOPReply();
			)

	      __GIOPLITE_PROTOCOL__(
			if (msg instanceof GIOPLiteMessage)
				rep = new GIOPLiteReply();
			)
			
			__MQCIOP_PROTOCOL__(	
			if (msg instanceof MQCIOPMessage)
				rep = new MQCIOPReply();
			)
		} 
		else if (msg.getMessageType() == Message.REQUEST_MSG)
		{
         __GIOP_PROTOCOL__(
			if (msg instanceof GIOPMessage)
				req = new GIOPRequest();
         )
         __GIOPLITE_PROTOCOL__(
			if (msg instanceof GIOPLiteRequest)
				req = new GIOPLiteRequest();
         )
         __MQCIOP_PROTOCOL__(
			if (msg instanceof MQCIOPRequest)
				req = new MQCIOPRequest();
         )
		}
		
      int start=msg.getBufferPtr();

      String tmp1 = msg.getEndianess() ? "LE" : "BE";
      String tmp2 = (msg.getMessageType() == 0) ? "REQUEST_MSG" : "REPLY_MSG";
      
		__GIOP_PROTOCOL__(
      System.out.print("GIOP v" + ((GIOPMessage) msg).getMajorVersion() + "." +
                         ((GIOPMessage) msg).getMinorVersion() + " " + tmp1 + " " + tmp2 +
                         " " + msg.getSize() + " bytes");      
		)
      __GIOPLITE_PROTOCOL__(
		System.out.println("GIOPLite " + tmp1 + " " + tmp2 + " " + msg.getSize() + " bytes");
      )
		
      __MQCIOP_PROTOCOL__(
		System.out.println("MQCIOP " + tmp1 + " " + tmp2 + " " + msg.getSize() + " bytes");
      )

      if (msg.getMessageType() == Message.REPLY_MSG)
      {
			rep.deMarshal(buf);
         System.out.println(" ReqID: " + rep.getReqID() + " RepStatus: " +
                            rep.getReplyStatus() + " MsgBody:");
         start = rep.getBufferPtr();
      }
      else
      {
			req.deMarshal(buf);
         System.out.println(" ReqID: " + req.getReqID() + " isOneWay: " +
                            req.isOneWay() + " ObjectKey: " + new String(req.getObjectKey()) +
                            " Operation: " + req.getOperation());
         start = req.getBufferPtr();
      }
		printHex(buf, start, eom);
	}

	public static void printHex(byte [] buf)
	{
		printHex(buf, 0, buf.length);
	}

	public static void printHex(byte [] buf, int start, int end)
	{
      int k=0;
      String temp = null;
      for (int i=start; i < end; i++)
      {
         if (temp != null)
			{
				String tmp1 = Integer.toHexString( buf[i] & 0xFF );
				if (tmp1.length() == 1) 
					tmp1 = "0" + tmp1;
            temp = temp + " 0x" + tmp1;
			}
         else
			{
				String tmp2 = Integer.toHexString( buf[i] & 0xFF );
				if (tmp2.length() == 1) 
					tmp2 = "0" + tmp2;
         	temp = "0x" + tmp2;
			}
         k++;

         if (k==15)
         {
            System.out.println(temp);
            temp = null;
            k=0;
         }
      }
      if (temp != null)
         System.out.println(temp);
      System.out.println();
   }
}
